/**
 * Generate text by GPT-3
 * 
 * @since 2.8.0
 */
jQuery( function( $ ) {
    'use strict';

	$( 'body' ).on( 'click', '.porto-ai-dialog:not(.loading) .btn-close', function (e) {
		e.preventDefault();
		$( '.porto-ai-dialog' ).addClass( 'hide' );
	} );

	$( 'body' ).on( 'click', '.porto-ai-dialog .btn-copy', function (e) {
		e.preventDefault();
		$( '#ai-output' ).trigger( 'select' );
        document.execCommand( 'copy' );
		$( this ).html( wp.i18n.__( 'Copied', 'porto-functionality' ) );
	} );

	$( 'body' ).on( 'click', '.ai_generate', function ( e ) {
		e.preventDefault();
		var $this = $(this),
			__ = wp.i18n.__,
			type = __( 'description', 'porto-functionality' ),
			$wrapper = $( '#porto-api-engine' ),
			addQuery = __( 'Write at least 5 paragraphs.', 'porto-functionality' );
			if ( typeof js_porto_admin_vars != 'undefined' && '' != js_porto_admin_vars.ai_key ) {
				if ( 'ai_excerpt' == $this.attr('id') ) {
					type = __( 'excerpt', 'porto-functionality' );
					addQuery = __( 'Write between 55 and 75 characters.', 'porto-functionality' );
				}
				var	title = $( '#title' ).length ? $( '#title' ).val() : $( 'h1.editor-post-title' ).html(),
					$dialog = $( '.porto-ai-dialog' ),
					$outText = $dialog.find( '.output' );

				if ( $wrapper.find( '#user_word' ) && $wrapper.find( '#user_word' ).val().length ) {
					addQuery = $wrapper.find( '#user_word' ).val().trim();
				}

				if ( '' == title || 'undefined' == typeof title || -1 != title.search( '<span' ) ) {
					window.alert( __( 'Please input the title.', 'porto-functionality' ) );
					return;
				}

				var data = {
					model: "text-davinci-003",
					prompt: __( "Please write a %1$s %2$s for title '%3$s'. %4$s", 'porto-functionality' ).replace( '%1$s', js_porto_admin_vars.post_type ).replace( '%2$s', type ).replace( '%3$s', title ).replace( '%4$s', addQuery ),
					max_tokens: 2048,
					temperature: 0.8
				},
				aiHttp = new XMLHttpRequest();
				aiHttp.open( "POST", "https://api.openai.com/v1/completions" );
				aiHttp.setRequestHeader( "Accept", "application/json" );
				aiHttp.setRequestHeader( "Content-Type", "application/json" );
				aiHttp.setRequestHeader( "timeout", "20000" );
				aiHttp.setRequestHeader( "Authorization", "Bearer " + js_porto_admin_vars.ai_key );

				// Edit dialog title
				$dialog.removeClass( 'hide' ).addClass('loading');
				$outText.val( '' );
				$dialog.find( '.btn-copy' ).html( __( 'Copy to Clipboard','porto-functionality' ) );
				aiHttp.onreadystatechange = function() {
					$dialog.removeClass('loading');
					if ( aiHttp.readyState == 4 && aiHttp.status == 200 ) {
						var response = JSON.parse( aiHttp.response );
						if ( 'undefined' != typeof response[ 'choices' ] && 'undefined' != typeof response[ 'choices' ][0] ) {
							$outText.val( response[ 'choices' ][0]['text'].trim() );
						}
					} else if ( 'undefined' != typeof aiHttp.response && null !== aiHttp.response.match( 'error' ) ) {
						var response = JSON.parse( aiHttp.response ),
						errorMessage = response['error']['message'];
						if ( errorMessage.match( 'API key provided(: .*)\.' ) ) {
							errorMessage = __( 'Incorrect API key provided.', 'porto-functionality' );
						}
						$outText.val( __( 'Error: %s', 'porto-functionality' ).replace( '%s', errorMessage ) );
					}
				}

				// Timeout
				aiHttp.ontimeout = function() {
					$outText.val( __( 'Request time is out.', 'porto-functionality' ) );
				};
				aiHttp.send( JSON.stringify( data ) );
			}
	})
} );